## ros-melodic-planner-cspace 0.10.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)
project(planner_cspace)

set(CATKIN_DEPENDS
  roscpp

  actionlib
  diagnostic_updater
  geometry_msgs
  move_base_msgs
  nav_msgs
  sensor_msgs
  std_srvs
  tf2
  tf2_geometry_msgs
  tf2_ros
  trajectory_msgs

  costmap_cspace
  costmap_cspace_msgs
  neonavigation_common
  planner_cspace_msgs
  trajectory_tracker_msgs
)

find_package(catkin REQUIRED COMPONENTS ${CATKIN_DEPENDS})
find_package(Boost REQUIRED COMPONENTS chrono)
find_package(OpenMP REQUIRED)
catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS ${CATKIN_DEPENDS}
)


set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_compile_options(-funroll-loops -finline-functions ${OpenMP_CXX_FLAGS})
include_directories(include ${catkin_INCLUDE_DIRS})


add_executable(planner_3d
  src/costmap_bbf.cpp
  src/grid_astar_model_3dof.cpp
  src/motion_cache.cpp
  src/motion_primitive_builder.cpp
  src/path_interpolator.cpp
  src/planner_3d.cpp
  src/rotation_cache.cpp
)
target_link_libraries(planner_3d ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})
add_dependencies(planner_3d ${catkin_EXPORTED_TARGETS})
set_property(TARGET planner_3d PROPERTY PUBLIC_HEADER
  include/planner_cspace/bbf.h
  include/planner_cspace/blockmem_gridmap.h
  include/planner_cspace/cyclic_vec.h
  include/planner_cspace/grid_astar.h
  include/planner_cspace/grid_astar_model.h
  include/planner_cspace/jump_detector.h
  include/planner_cspace/reservable_priority_queue.h
)

add_executable(planner_2dof_serial_joints
  src/planner_2dof_serial_joints.cpp
  src/grid_astar_model_2dof_joints.cpp
)
target_link_libraries(planner_2dof_serial_joints ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})
add_dependencies(planner_2dof_serial_joints ${catkin_EXPORTED_TARGETS})

add_executable(dummy_robot src/dummy_robot.cpp)
target_link_libraries(dummy_robot ${catkin_LIBRARIES})
add_dependencies(dummy_robot ${catkin_EXPORTED_TARGETS})

add_executable(patrol src/patrol.cpp)
target_link_libraries(patrol ${catkin_LIBRARIES})
add_dependencies(patrol ${catkin_EXPORTED_TARGETS})


if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_subdirectory(test)
  find_package(roslint REQUIRED)
  roslint_cpp()
  roslint_add_test()
endif()


install(TARGETS
    dummy_robot
    patrol
    planner_2dof_serial_joints
    planner_3d
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  PUBLIC_HEADER DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

=== test/CMakeLists.txt ===
catkin_add_gtest(test_blockmem_gridmap src/test_blockmem_gridmap.cpp)
target_link_libraries(test_blockmem_gridmap ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_grid_astar src/test_grid_astar.cpp)
target_link_libraries(test_grid_astar ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})

catkin_add_gtest(test_cyclic_vec src/test_cyclic_vec.cpp)
target_link_libraries(test_cyclic_vec ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_grid_metric_converter src/test_grid_metric_converter.cpp)
target_link_libraries(test_grid_metric_converter ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_planner_3d_cost
  src/test_planner_3d_cost.cpp
  ../src/grid_astar_model_3dof.cpp
  ../src/motion_cache.cpp
  ../src/motion_primitive_builder.cpp
  ../src/rotation_cache.cpp
)
target_link_libraries(test_planner_3d_cost ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_costmap_bbf
  src/test_costmap_bbf.cpp
  ../src/costmap_bbf.cpp
)
target_link_libraries(test_costmap_bbf ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_motion_cache
  src/test_motion_cache.cpp
  ../src/motion_cache.cpp
)
target_link_libraries(test_motion_cache ${catkin_LIBRARIES} ${Boost_LIBRARIES})

catkin_add_gtest(test_motion_primitive_builder
  src/test_motion_primitive_builder.cpp
  ../src/motion_primitive_builder.cpp
  ../src/rotation_cache.cpp
)
target_link_libraries(test_motion_primitive_builder ${catkin_LIBRARIES} ${Boost_LIBRARIES})

add_rostest_gtest(test_debug_outputs
  test/debug_outputs_rostest.test
  src/test_debug_outputs.cpp
)
target_link_libraries(test_debug_outputs ${catkin_LIBRARIES})
add_dependencies(test_debug_outputs planner_3d)

add_rostest_gtest(test_navigate
  test/navigation_rostest.test
  src/test_navigate.cpp
)
target_link_libraries(test_navigate ${catkin_LIBRARIES})
add_dependencies(test_navigate planner_3d)

add_rostest(test/navigation_rostest.test
  ARGS antialias_start:=true
  DEPENDENCIES test_navigate
)

add_rostest(test/navigation_rostest.test
  ARGS antialias_start:=true fast_map_update:=true
  DEPENDENCIES test_navigate
)

add_rostest(test/navigation_rostest.test
  ARGS with_tolerance:=true
  DEPENDENCIES test_navigate
)

add_rostest(test/navigation_compat_rostest.test
  DEPENDENCIES test_navigate
)

add_rostest_gtest(test_navigate_boundary
  test/navigation_boundary_rostest.test
  src/test_navigate_boundary.cpp
)
target_link_libraries(test_navigate_boundary ${catkin_LIBRARIES})
add_dependencies(test_navigate_boundary planner_3d)

add_rostest_gtest(test_abort
  test/abort_rostest.test
  src/test_abort.cpp
)
target_link_libraries(test_abort ${catkin_LIBRARIES})
add_dependencies(test_abort planner_3d)

add_rostest_gtest(test_preempt
  test/preempt_rostest.test
  src/test_preempt.cpp
)
target_link_libraries(test_preempt ${catkin_LIBRARIES})
add_dependencies(test_preempt planner_3d)

add_rostest_gtest(test_costmap_watchdog
  test/costmap_watchdog_rostest.test
  src/test_costmap_watchdog.cpp
)
target_link_libraries(test_costmap_watchdog ${catkin_LIBRARIES})
add_dependencies(test_costmap_watchdog planner_3d)

add_rostest_gtest(test_planner_2dof_serial_joints
  test/planner_2dof_serial_joints_rostest.test
  src/test_planner_2dof_serial_joints.cpp
)
target_link_libraries(test_planner_2dof_serial_joints ${catkin_LIBRARIES})
add_dependencies(test_planner_2dof_serial_joints planner_2dof_serial_joints)


if(NEONAVIGATION_EXTRA_TESTS)

  catkin_add_gtest(test_blockmem_gridmap_performance
    src/test_blockmem_gridmap_performance.cpp
  )
  target_link_libraries(test_blockmem_gridmap_performance ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})
  # Force release build for performance test.
  set_target_properties(test_blockmem_gridmap_performance PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS_RELEASE}")

endif()

=== debian/changelog ===
ros-melodic-planner-cspace (0.10.4-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 12 Nov 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.10.3-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 22 Oct 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.10.2-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.10.1-1stretch) stretch; urgency=high

  * planner_cspace: avoid publishing invalid path when escaping (#546 <https://github.com/at-wat/neonavigation/issues/546>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 26 Aug 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.10.0-1stretch) stretch; urgency=high

  * planner_cspace: add test to MoveWithToleranceAction (#528 <https://github.com/at-wat/neonavigation/issues/528>)
  * planner_cspace: add test to distance map debug output (#526 <https://github.com/at-wat/neonavigation/issues/526>)
  * planner_cspace: periodically update local map in the test (#522 <https://github.com/at-wat/neonavigation/issues/522>)
  * Merge rostest coverage profiles (#520 <https://github.com/at-wat/neonavigation/issues/520>)
  * planner_cspace: fix search range of minimum cost in fast_map_update mode (#518 <https://github.com/at-wat/neonavigation/issues/518>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 06 Aug 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.9.1-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 16 Jul 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.9.0-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 02 Jul 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.8-1stretch) stretch; urgency=high

  * planner_cspace: avoid showing too many warning messages (#501 <https://github.com/at-wat/neonavigation/issues/501>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 15 Jun 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.7-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 22 May 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.6-1stretch) stretch; urgency=high

  * Fix duplicated tf timestamp (#494 <https://github.com/at-wat/neonavigation/issues/494>)
  * planner_cspace: add wait to navigation tests (#492 <https://github.com/at-wat/neonavigation/issues/492>)
  * planner_cspace: simplify path switch detection condition (#488 <https://github.com/at-wat/neonavigation/issues/488>)
  * planner_cspace: fix uninitialized variable (#486 <https://github.com/at-wat/neonavigation/issues/486>)
  * planner_cspace: enable replan when robot reaches the switchback point (#449 <https://github.com/at-wat/neonavigation/issues/449>)
  * planner_cspace: fix test_debug_outputs initial wait (#485 <https://github.com/at-wat/neonavigation/issues/485>)
  * Contributors: Atsushi Watanabe, Kazuki Takahashi

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 15 May 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.5-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 04 May 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.4-1stretch) stretch; urgency=high

  * Clean unused dependencies (#472 <https://github.com/at-wat/neonavigation/issues/472>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 30 Apr 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.3-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 26 Apr 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.2-1stretch) stretch; urgency=high

  * Support Noetic (#461 <https://github.com/at-wat/neonavigation/issues/461>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 07 Apr 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.1-1stretch) stretch; urgency=high

  * planner_cspace: fix flaky debug_output test (#452 <https://github.com/at-wat/neonavigation/issues/452>)
  * planner_cspace: fix condition of planning finish (#451 <https://github.com/at-wat/neonavigation/issues/451>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 12 Mar 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.8.0-1stretch) stretch; urgency=high

  * planner_cspace: replan immediately when path is blocked by new obstacles (#446 <https://github.com/at-wat/neonavigation/issues/446>)
  * Add message package version constraints (#443 <https://github.com/at-wat/neonavigation/issues/443>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 04 Mar 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.7.0-1stretch) stretch; urgency=high

  * planner_cspace: add MoveWithToleranceAction server (#433 <https://github.com/at-wat/neonavigation/issues/433>)
  * planner_cspace: fix typo (#436 <https://github.com/at-wat/neonavigation/issues/436>)
  * planner_cspace: implement motion primitive algorithm for speed-up (#431 <https://github.com/at-wat/neonavigation/issues/431>)
  * Contributors: Daiki Maekawa, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 04 Feb 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.6.0-1stretch) stretch; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sat, 18 Jan 2020 00:00:00 -0000

ros-melodic-planner-cspace (0.5.1-1stretch) stretch; urgency=high

  * planner_cspace: disable blockmem_gridmap_performance test (#413 <https://github.com/at-wat/neonavigation/issues/413>)
  * Fix header namespaces (#408 <https://github.com/at-wat/neonavigation/issues/408>)
  * planner_cspace: fix installing planner_2dof_serial_joints node (#409 <https://github.com/at-wat/neonavigation/issues/409>)
  * Migrate from C math functions to C++ (#407 <https://github.com/at-wat/neonavigation/issues/407>)


=== debian/control ===
Source: ros-melodic-planner-cspace
Section: misc
Priority: optional
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-actionlib, ros-melodic-catkin, ros-melodic-costmap-cspace, ros-melodic-costmap-cspace-msgs, ros-melodic-diagnostic-updater, ros-melodic-geometry-msgs, ros-melodic-map-server, ros-melodic-move-base-msgs, ros-melodic-nav-msgs, ros-melodic-neonavigation-common, ros-melodic-planner-cspace-msgs (>= 0.7.0), ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-trajectory-msgs, ros-melodic-trajectory-tracker, ros-melodic-trajectory-tracker-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-planner-cspace
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-actionlib, ros-melodic-costmap-cspace, ros-melodic-costmap-cspace-msgs, ros-melodic-diagnostic-updater, ros-melodic-geometry-msgs, ros-melodic-move-base-msgs, ros-melodic-nav-msgs, ros-melodic-neonavigation-common, ros-melodic-planner-cspace-msgs (>= 0.7.0), ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-trajectory-msgs, ros-melodic-trajectory-tracker-msgs
Description: 3-dof configuration space planner for mobile robot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-planner-cspace//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-planner-cspace 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
   costmap_cspace
   costmap_cspace_msgs
   neonavigation_common
+  neonavigation_metrics_msgs
   planner_cspace_msgs
   trajectory_tracker_msgs
 )
@@ -32,7 +33,7 @@
 )
 
 
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 add_compile_options(-funroll-loops -finline-functions ${OpenMP_CXX_FLAGS})
@@ -46,6 +47,7 @@
   src/motion_primitive_builder.cpp
   src/path_interpolator.cpp
   src/planner_3d.cpp
+  src/distance_map.cpp
   src/rotation_cache.cpp
 )
 target_link_libraries(planner_3d ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+include_directories(include)
+
 catkin_add_gtest(test_blockmem_gridmap src/test_blockmem_gridmap.cpp)
 target_link_libraries(test_blockmem_gridmap ${catkin_LIBRARIES} ${Boost_LIBRARIES})
 
@@ -6,6 +8,26 @@
 
 catkin_add_gtest(test_cyclic_vec src/test_cyclic_vec.cpp)
 target_link_libraries(test_cyclic_vec ${catkin_LIBRARIES} ${Boost_LIBRARIES})
+
+catkin_add_gtest(test_distance_map
+  src/test_distance_map.cpp
+  ../src/distance_map.cpp
+  ../src/grid_astar_model_3dof.cpp
+  ../src/motion_cache.cpp
+  ../src/motion_primitive_builder.cpp
+  ../src/rotation_cache.cpp
+)
+target_link_libraries(test_distance_map ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})
+
+catkin_add_gtest(test_distance_map_fast_update
+  src/test_distance_map_fast_update.cpp
+  ../src/distance_map.cpp
+  ../src/grid_astar_model_3dof.cpp
+  ../src/motion_cache.cpp
+  ../src/motion_primitive_builder.cpp
+  ../src/rotation_cache.cpp
+)
+target_link_libraries(test_distance_map_fast_update ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${OpenMP_CXX_FLAGS})
 
 catkin_add_gtest(test_grid_metric_converter src/test_grid_metric_converter.cpp)
 target_link_libraries(test_grid_metric_converter ${catkin_LIBRARIES} ${Boost_LIBRARIES})
@@ -37,6 +59,13 @@
   ../src/rotation_cache.cpp
 )
 target_link_libraries(test_motion_primitive_builder ${catkin_LIBRARIES} ${Boost_LIBRARIES})
+
+catkin_add_gtest(test_path_interpolator
+  src/test_path_interpolator.cpp
+  ../src/path_interpolator.cpp
+  ../src/rotation_cache.cpp
+)
+target_link_libraries(test_path_interpolator ${catkin_LIBRARIES} ${Boost_LIBRARIES})
 
 add_rostest_gtest(test_debug_outputs
   test/debug_outputs_rostest.test
@@ -106,6 +135,20 @@
 target_link_libraries(test_planner_2dof_serial_joints ${catkin_LIBRARIES})
 add_dependencies(test_planner_2dof_serial_joints planner_2dof_serial_joints)
 
+add_rostest_gtest(test_planner_3d_map_size
+  test/planner_3d_map_size_rostest.test
+  src/test_planner_3d_map_size.cpp
+)
+target_link_libraries(test_planner_3d_map_size ${catkin_LIBRARIES})
+add_dependencies(test_planner_3d_map_size planner_3d)
+
+add_rostest_gtest(test_tolerant_action
+  test/tolerant_action_rostest.test
+  src/test_tolerant_action.cpp
+)
+target_link_libraries(test_tolerant_action ${catkin_LIBRARIES})
+add_dependencies(test_tolerant_action planner_3d)
+
 
 if(NEONAVIGATION_EXTRA_TESTS)

=== debian/changelog ===
ros-melodic-planner-cspace (0.14.0-1bionic) bionic; urgency=high

  * planner_cspace: publish planner_3d metrics (#701 <https://github.com/at-wat/neonavigation/issues/701>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 06 Jun 2023 00:00:00 -0000

ros-melodic-planner-cspace (0.13.0-1bionic) bionic; urgency=high

  * planner_cspace: fix fast map update (#692 <https://github.com/at-wat/neonavigation/issues/692>)
  * planner_cspace: fix status when goal or robot is in rock on updating goal (#694 <https://github.com/at-wat/neonavigation/issues/694>)
  * planner_cspace: fix string template constexpr in test (#685 <https://github.com/at-wat/neonavigation/issues/685>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 31 May 2023 00:00:00 -0000

ros-melodic-planner-cspace (0.12.2-1bionic) bionic; urgency=high

  * planner_cspace: fix planner_2dof_serial_joints status (#682 <https://github.com/at-wat/neonavigation/issues/682>)
  * planner_cspace: set timestamp to planner status message (#681 <https://github.com/at-wat/neonavigation/issues/681>)
  * planner_cspace: fix uninitialized variables in DistanceMap (#679 <https://github.com/at-wat/neonavigation/issues/679>)
  * planner_cspace: add scoped trace to some test cases (#680 <https://github.com/at-wat/neonavigation/issues/680>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 28 Feb 2023 00:00:00 -0000

ros-melodic-planner-cspace (0.12.1-1bionic) bionic; urgency=high

  * Improve test logs on timeout (#673 <https://github.com/at-wat/neonavigation/issues/673>)
  * planner_cspace: fix map update range (#672 <https://github.com/at-wat/neonavigation/issues/672>)
  * planner_cspace: clear velocity of dummy_robot on position set (#669 <https://github.com/at-wat/neonavigation/issues/669>)
  * planner_cspace: fix flaky action tests (#665 <https://github.com/at-wat/neonavigation/issues/665>)
  * planner_cspace: fix planner_cspace_msgs version constraint (#663 <https://github.com/at-wat/neonavigation/issues/663>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sat, 25 Feb 2023 00:00:00 -0000

ros-melodic-planner-cspace (0.12.0-1bionic) bionic; urgency=high

  * planner_cspace: add continuous movement mode to MoveWithTolerance (#652 <https://github.com/at-wat/neonavigation/issues/652>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 30 Jan 2023 00:00:00 -0000

ros-melodic-planner-cspace (0.11.8-1bionic) bionic; urgency=high

  * planner_cspace: add missing array include (#658 <https://github.com/at-wat/neonavigation/issues/658>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 28 Dec 2022 00:00:00 -0000

ros-melodic-planner-cspace (0.11.7-1bionic) bionic; urgency=high

  * planner_cspace: fix pose duplication on path interpolation (#648 <https://github.com/at-wat/neonavigation/issues/648>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 05 Aug 2022 00:00:00 -0000

ros-melodic-planner-cspace (0.11.6-1bionic) bionic; urgency=high

  * planner_cspace: add more test case to Planner3DMapSize (#640 <https://github.com/at-wat/neonavigation/issues/640>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 20 Jul 2022 00:00:00 -0000

ros-melodic-planner-cspace (0.11.5-1bionic) bionic; urgency=high

  * planner_cspace: fix access violation on wrong size costmap_update message (#637 <https://github.com/at-wat/neonavigation/issues/637>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 06 Jul 2022 00:00:00 -0000

ros-melodic-planner-cspace (0.11.4-1bionic) bionic; urgency=high



 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 13 Apr 2022 00:00:00 -0000

ros-melodic-planner-cspace (0.11.3-1bionic) bionic; urgency=high

  * planner_cspace: fix DistanceMap::init() (#625 <https://github.com/at-wat/neonavigation/issues/625>)
  * Fix flaky tests and add debug outputs (#628 <https://github.com/at-wat/neonavigation/issues/628>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 02 Dec 2021 00:00:00 -0000

ros-melodic-planner-cspace (0.11.2-1bionic) bionic; urgency=high

  * planner_cspace: Fix header of fihish path (#622 <https://github.com/at-wat/neonavigation/issues/622>)
  * Contributors: Kazuki Takahashi

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 08 Nov 2021 00:00:00 -0000

ros-melodic-planner-cspace (0.11.1-1bionic) bionic; urgency=high

  * planner_cspace: refactor distance map generator (#617 <https://github.com/at-wat/neonavigation/issues/617>)
  * planner_cspace: recover error on FINISHING state (#615 <https://github.com/at-wat/neonavigation/issues/615>)
  * planner_cspace: fix flaky actionlib tests (#616 <https://github.com/at-wat/neonavigation/issues/616>)
  * planner_cspace: remove unused variable (#614 <https://github.com/at-wat/neonavigation/issues/614>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 29 Oct 2021 00:00:00 -0000

ros-melodic-planner-cspace (0.11.0-1bionic) bionic; urgency=high

  * Apply clang-format-11 with new setting (#605 <https://github.com/at-wat/neonavigation/issues/605>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 30 Aug 2021 00:00:00 -0000

ros-melodic-planner-cspace (0.10.11-1bionic) bionic; urgency=high

  * planner_cspace: reset next_replan_time after waitUntil() (#602 <https://github.com/at-wat/neonavigation/issues/602>)
  * Contributors: Kazuki Takahashi

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 21 Jun 2021 00:00:00 -0000

ros-melodic-planner-cspace (0.10.10-1bionic) bionic; urgency=high

  * planner_cspace: fix goal unreachable condition (#595 <https://github.com/at-wat/neonavigation/issues/595>)
  * Contributors: Atsushi Watanabe



=== debian/control ===
Source: ros-melodic-planner-cspace
Section: misc
Priority: optional
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-actionlib, ros-melodic-catkin, ros-melodic-costmap-cspace, ros-melodic-costmap-cspace-msgs, ros-melodic-diagnostic-updater, ros-melodic-geometry-msgs, ros-melodic-map-server <!nocheck>, ros-melodic-move-base-msgs, ros-melodic-nav-msgs, ros-melodic-neonavigation-common, ros-melodic-neonavigation-metrics-msgs, ros-melodic-planner-cspace-msgs (>= 0.12.0), ros-melodic-roscpp, ros-melodic-roslint <!nocheck>, ros-melodic-rostest <!nocheck>, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-trajectory-msgs, ros-melodic-trajectory-tracker <!nocheck>, ros-melodic-trajectory-tracker-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-planner-cspace
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-actionlib, ros-melodic-costmap-cspace, ros-melodic-costmap-cspace-msgs, ros-melodic-diagnostic-updater, ros-melodic-geometry-msgs, ros-melodic-move-base-msgs, ros-melodic-nav-msgs, ros-melodic-neonavigation-common, ros-melodic-neonavigation-metrics-msgs, ros-melodic-planner-cspace-msgs (>= 0.12.0), ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-trajectory-msgs, ros-melodic-trajectory-tracker-msgs
Description: 3-dof configuration space planner for mobile robot

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
